import * as ts from 'typescript';
export declare function getAnonymousName(): string;
export declare function formatUrl(url: string): string;
export declare function formatName(name: string): string;
export declare function getTypeArguments(node: ts.TypeNode): ts.NodeArray<ts.TypeNode> | undefined;
export declare function getSymbol(node: ts.Node): ts.Symbol | undefined;
export declare function getDeclarationBySymbol(symbol: ts.Symbol): ts.Declaration;
export declare function getJSDocProp(node: ts.Node): ts.JSDoc[] | undefined;
export declare function getJSDoc(node: ts.Node): ts.JSDoc | undefined;
export declare function getDeclarationMayHasJSDoc(node: ts.Node): ts.Node;
export declare function getJSDocs(node: ts.Node): ts.JSDoc[] | undefined;
export declare function hasQuestionToken(node: ts.Node): boolean;
export declare function isDeclareModule(node: ts.Node): node is ts.ModuleDeclaration;
export declare function getText(node?: ts.Node): string;
export declare function findJsDocTag(node: ts.Node, name: string): ts.JSDocTag | undefined;
export declare function normalizeDtsUrl(file: string): string;
export declare function resolveUrl(url: string): string | undefined;
export declare function modifierHas(node: ts.Node, kind: any): ts.Token<ts.SyntaxKind.AbstractKeyword> | ts.Token<ts.SyntaxKind.AsyncKeyword> | ts.Token<ts.SyntaxKind.ConstKeyword> | ts.Token<ts.SyntaxKind.DeclareKeyword> | ts.Token<ts.SyntaxKind.DefaultKeyword> | ts.Token<ts.SyntaxKind.ExportKeyword> | ts.Token<ts.SyntaxKind.PublicKeyword> | ts.Token<ts.SyntaxKind.PrivateKeyword> | ts.Token<ts.SyntaxKind.ProtectedKeyword> | ts.Token<ts.SyntaxKind.ReadonlyKeyword> | ts.Token<ts.SyntaxKind.StaticKeyword> | undefined;
export interface AssignElement {
    init?: boolean;
    obj?: ts.Expression;
    key: ts.Identifier;
    value?: ts.Expression;
    node: ts.Node;
}
export interface ExportObj {
    node: ts.Node;
    originalNode: ts.Node;
}
export declare function findExports(source: ts.SourceFile): {
    exportEqual: ExportObj | undefined;
    exportList: Map<string, ExportObj>;
};
export declare function findAssign(statements: ts.NodeArray<ts.Statement>, cb: (result: AssignElement) => void): void;
export declare function findAssignByName(statements: any, name: FindAssignNameType | FindAssignNameType[], cb: (result: AssignNameElement) => void): void;
declare type FindAssignNameType = string | RegExp;
interface AssignNameElement extends AssignElement {
    obj: ts.Expression;
    name: string;
    value: ts.Expression;
}
export declare function getAssignChecker(name: FindAssignNameType | FindAssignNameType[]): {
    check(el: AssignElement): AssignNameElement | undefined;
};
export declare function getAssignResultFromStatement(statement: ts.Statement, assignList?: AssignElement[]): AssignElement[];
export {};
//# sourceMappingURL=util.d.ts.map